#include <bits/stdc++.h>
using namespace std;

void solve(){
	int N, M;
	cin >> N >> M;
	int d = 0;
	for(int i = 0; i < M; i++){
		int u, v;
		cin >> u >> v;
		u--; v--;
		if(u < v){
			d++;
		} else {
			d--;
		}
	}
	for(int i = 0; i < N; i++){
		cout << (d >= 0 ? (i+1) : (N-i)) << " \n"[i == N-1];
	}
}

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int T;
	cin >> T;
	while(T--) solve();
}
